function [errpruh,errj,errkriz,omegaj,omegakriz]=MNDerr(X,Y,tolerance,rovnat,lamnula);

% funkce pro vypocet pomeru chyby metodou jackknife
% a metodou krizoveho porovnani
% v modelu smesi normalnich rozdeleni 
% podrobneji viz kapitola VII

%X...matice vysvetlujicich velicin (typu n x p)
%Y...vektor zarazeni jednotlivych objektu (typu n x 1)

n=size(X,1);
p=size(X,2);

Z=[X,Y];

% vypocet prumeru v jednotlivych skupinach
n1=sum(Y);    % pocet jedincu prvni skupiny
n0=n-n1;      % pocet jedincu nulte skupiny

Z=sortrows(Z,(p+1));
X1=Z((n0+1):n,1:p);
X0=Z(1:n0,1:p);

X1prumer=(1/n1)*(sum(X1))';
X0prumer=(1/n0)*(sum(X0))';

% setrideni dat podle sloupce rovnat od nejvetsich po nejmensi
pomocnamatice=-Z;
pomocnamatice=sortrows(pomocnamatice,rovnat);
Z=-pomocnamatice;
X=Z(:,1:p);
Y=Z(:,(p+1));

%vypocet errpruh
[mu1,mu0,lam,sig,llog,pocit,tolkonec,norm]=MNDest(X,tolerance,0,lamnula);

% alespon castecna kontrola, jestli je lambda skutecne podil jedincu 
% prvni skupiny
% EM alg. by mohl vratit v mu1 odhad stredni hod. pro Y=0 a v lam podil
% jedincu s Y=0
if (X1prumer(1,1)-X0prumer(1,1))*(mu1(1,1)-mu0(1,1))<0
   ooooo=mu1;
   mu1=mu0;
   mu0=ooooo;
   lam=1-lam;
end;

[beta0,beta]=MNDbetas(mu1,mu0,lam,sig);
soucetpropruh=0;
for i=1:n
   if beta0+X(i,:)*beta<0
      zarad(i)=0;
   else
      zarad(i)=1;
   end;
   if zarad(i)==(1-Y(i))        % spatne zarazeny objekt
      soucetpropruh=soucetpropruh+1;
   end;   
end;
errpruh=(1/n)*soucetpropruh;         

%vypocet koeficientu pro rozhodovaci procedury
%sestavene bez i-teho pozorovani
for i=1:n
   Xzac=X(1:(i-1),:);
   Xkon=X((i+1):n,:);
   Xi=[Xzac;Xkon];
   [mu1,mu0,lam,sig,llog,pocit,tolkonec,norm]=MNDest(Xi,tolerance,0,lamnula);
   if (X1prumer(1,1)-X0prumer(1,1))*(mu1(1,1)-mu0(1,1))<0
      ooooo=mu1;
      mu1=mu0;
      mu0=ooooo;
      lam=1-lam;
   end;
[beta0(i),beta(:,i)]=MNDbetas(mu1,mu0,lam,sig);   
end;

%vypocet i-teho scitance pro urceni omega^j a omega^kriz
for i=1:n
   % vypocet druhe pulky scitance pro omega^kriz
   druhapulkakriz=abs(zarad(i)-Y(i));
   
   % vypocet druhe pulky scitance pro omega^j
   soucet=0;
   for j=1:n
      if beta0(j)+X(i,:)*beta(:,j)<0  % zarazuji i-ty objekt pomoci procedury 
                                    % ziskane bez j-teho pozorovani
         zaradit(j)=0;
      else
         zaradit(j)=1;
      end;
      if zaradit(j)==1-Y(i)        % spatne zarazeny objekt
         soucet=soucet+1;
      end;   
   end;   
   druhapulkaj=(1/n)*soucet;
   
   % vypocet prvni pulky scitance pro obe omegy
   if zaradit(i)==1-Y(i)
      prvnipulka=1;
   else
      prvnipulka=0;
   end;
   
   omegajscitanec(i)=prvnipulka-druhapulkaj;
   omegakrizscitanec(i)=prvnipulka-druhapulkakriz;
end;

velkysoucetj=sum(omegajscitanec);
velkysoucetkriz=sum(omegakrizscitanec);

omegaj=(1/n)*velkysoucetj;
omegakriz=(1/n)*velkysoucetkriz;

errj=omegaj+errpruh;
errkriz=omegakriz+errpruh;

