function [errpruh,errj,errkriz,omegaj,omegakriz]=NDAerr(X,Y);

% funkce pro vypocet pomeru chyby metodou jackknife
% a metodou krizoveho porovnani
% v modelu normalni diskriminacni analyzy 
% podrobneji viz kapitola VII

%X...matice vysvetlujicich velicin (typu n x p)
%Y...vektor zarazeni jednotlivych objektu (typu n x 1)

n=size(X,1);
p=size(X,2);

%vypocet errpruh
[beta0,beta]=NDAbetas(X,Y);
soucetpropruh=0;
for i=1:n
   if beta0+X(i,:)*beta<0
      zarad(i)=0;
   else
      zarad(i)=1;
   end;
   if zarad(i)==(1-Y(i))        % spatne zarazeny objekt
      soucetpropruh=soucetpropruh+1;
   end;   
end;
errpruh=(1/n)*soucetpropruh;        

%vypocet koeficientu pro rozhodovaci procedury
%sestavene bez i-teho pozorovani
for i=1:n
   Xzac=X(1:(i-1),:);
   Xkon=X((i+1):n,:);
   Yzac=Y(1:(i-1),:);
   Ykon=Y((i+1):n,:);
   Xi=[Xzac;Xkon];
   Yi=[Yzac;Ykon];
   [beta0(i),beta(:,i)]=NDAbetas(Xi,Yi);
end;

%vypocet i-teho scitance pro urceni omega^j a omega^kriz
for i=1:n
   % vypocet druhe pulky scitance pro omega^kriz
   druhapulkakriz=abs(zarad(i)-Y(i));
   
   % vypocet druhe pulky scitance pro omega^j
   soucet=0;
   for j=1:n
      if beta0(j)+X(i,:)*beta(:,j)<0  % zarazuji i-ty objekt pomoci procedury 
                                    % ziskane bez j-teho pozorovani
         zaradit(j)=0;
      else
         zaradit(j)=1;
      end;
      if zaradit(j)==1-Y(i)        % spatne zarazeny objekt
         soucet=soucet+1;
      end;   
   end;   
   druhapulkaj=(1/n)*soucet;
   
   % vypocet prvni pulky scitance pro obe omegy
   if zaradit(i)==1-Y(i)
      prvnipulka=1;
   else
      prvnipulka=0;
   end;
   
   omegajscitanec(i)=prvnipulka-druhapulkaj;
   omegakrizscitanec(i)=prvnipulka-druhapulkakriz;
end;

velkysoucetj=sum(omegajscitanec);
velkysoucetkriz=sum(omegakrizscitanec);

omegaj=(1/n)*velkysoucetj;
omegakriz=(1/n)*velkysoucetkriz;

errj=omegaj+errpruh;
errkriz=omegakriz+errpruh;

